<?php
define( RANKMOD_VER, '1.01');

require_once( 'mods/rank_mod/settings_defines.php' );

$modInfo['rank_mod']['name'] = "RankMod " . RANKMOD_VER . " by Chro'Tal";
$modInfo['rank_mod']['abstract'] = "Assigns ranks, medals and ribbons based on pilot performance.";
$modInfo['rank_mod']['about'] = 'Download and forum, see <a href="http://eve-id.net/forum/viewtopic.php?f=505&t=17825">EVEDK Forum</a>';

event::register( 'home_context_assembling', 'RankModHome::buildMenu' ); // hook custom awardboxes into killboard homepage

event::register( 'award_assembling', 'RankModAwards::buildMenu' ); // hook custom awardboxes into killboard awards page

//event::register( 'allianceDetail_assembling', 'RankModAllianceDetails::addViews' ); // hook custom menus into alliance details
//event::register( 'allianceDetail_context_assembling', 'RankModAllianceDetails::buildMenu' );

event::register( 'corpDetail_assembling', 'RankModCorpDetails::addViews' ); // hook custom menus into corp details
event::register( 'corpDetail_context_assembling', 'RankModCorpDetails::buildMenu' );

/* this is not ready yet...
event::register( 'pilotDetail_assembling', 'RankModPilotDetails::addViews' ); // hook custom menus into pilot details
event::register( 'pilotDetail_context_assembling', 'RankModPilotDetails::buildMenu' );

event::register( 'pilotDetail_assembling', 'RankModPilotDetails::addNewStuff' );*/

class RankModHome
{
	public static function buildMenu( $home )
	{
		$home->replace( 'topLists', "RankModHome::topLists" );
	}
	
	public static function topLists( $home )
	{
		if( $home->getView() != 'losses' )
		{
			$tkbox = new RankModAwardBox( RankModAwards::getTopKiller( $home ,config::get('show_monthly')), "Top killers", "ship kills in " . $home->getCurrentPeriod(), "kills", "killer" );
			$html .= $tkbox->generate();
			
			$tkbox = new RankModAwardBox( RankModAwards::getTopScorer( $home , config::get('show_monthly')), "Top scorers", "killpoints in " . $home->getCurrentPeriod(), "points", "scorer" );
			$html .= $tkbox->generate();
		}
		
		if( $home->getView() == 'losses' )
		{
			$tkbox = new RankModAwardBox( RankModAwards::getTopLoser( $home , config::get('show_monthly')), "Top loosers", "ships lost in " . $home->getCurrentPeriod(), "losses", "loser" );
			$html .= $tkbox->generate();
		}
		
		return $html;
	}
}


class RankModAwards
{
	public function getMonth() {
		return $this->month;
	}
	public function getYear() {
		return $this->year;
	}
	public static function buildMenu( $home )
	{
		$home->replace( 'awards', "RankModAwards::assembleAwards" );
	}
	
	public static function assembleAwards( $home )
	{
		global $smarty;
		$awardboxes = array();
		if( config::get( 'rankmod_activeawards' ) && count( config::get( 'rankmod_activeawards' ) ) > 0 )
		{
			foreach( config::get( 'rankmod_activeawards' ) as $activeaward_id )
			{
				switch( $activeaward_id )
				{
					case 1:
						// top killers
						$tkbox = new RankModAwardBox( RankModAwards::getTopKiller( $home, true), "Top killers", "ship kills", "kills", "killer" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
					
					case 2:
						// top scorers
						$tkbox = new RankModAwardBox( RankModAwards::getTopScorer( $home, true), "Top scorers", "points", "points", "scorer" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 3:
						// top solo killers
						$tkbox = new RankModAwardBox( RankModAwards::getTopSoloKiller( $home , true), "Top solo killers", "solo ship kills", "kills", "solokiller" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 4:
						// top damage dealers
						$tkbox = new RankModAwardBox( RankModAwards::getTopDamagedealer( $home , true), "Top damage dealers", "kills w/ most damage", "kills", "damagedealer" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 5:
						// top final blows		
						$tkbox = new RankModAwardBox( RankModAwards::getTopFinalBlow( $home , true), "Top kill snatchers", "final blows", "kills", "finalblows" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 6:
						// top podkillers
						$tkbox = new RankModAwardBox( RankModAwards::getTopPodKiller( $home , true), "Top pod killers", "podkills", "kills", "podkiller" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 7:
						// top griefers
						$tkbox = new RankModAwardBox( RankModAwards::getTopGriefer( $home , true), "Top griefers", "tearful carebear kills", "kills", "griefer" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 8:
						// top ISK destroyed
						$tkbox = new RankModAwardBox( RankModAwards::getTopISKKiller( $home , true), "Top ISK killers", "ISK damage caused", "kills", "iskkiller" );
						$tkbox->setISKConvert();
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 9:
						// top loser
						$tkbox = new RankModAwardBox( RankModAwards::getTopLoser( $home , true), "Top losers", "most ships lost", "kills", "loser" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 10:
						// top pirates
						$tkbox = new RankModAwardBox( RankModAwards::getTopPirate( $home , true), "Top pirates", "lowsec kills", "kills", "pirate" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 11:
						// top capital killers
						$tkbox = new RankModAwardBox( RankModAwards::getTopCapitalKiller( $home , true), "Top capital killers", "capital shipkills", "kills", "capitalkiller" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 12:
						// top demolitions
						$tkbox = new RankModAwardBox( RankModAwards::getTopStructureKiller( $home , true), "Top demolition experts", "structures destroyed", "kills", "demolitions" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 13:
						// top highsec
						$tkbox = new RankModAwardBox( RankModAwards::getTopHighsec( $home , true), "Top highsec enforcer", "highsec kills", "kills", "highseckiller" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
						
					case 14:
						// top highsec loser
						$tkbox = new RankModAwardBox( RankModAwards::getTopHighsecLoser( $home ,  true), "Top highsec losers", "highsec ships lost", "kills", "highsecloser" );
						$awardboxes[] = $tkbox->generate();
						unset( $tkbox );
						
						break;
				}
			}
		}
		else 
		{
			echo '<span style="color:red; font-weight:bold;">RankMod has not been configured, thus this page will not display properly. <br><br>Check admin settings and SAVE settings on all config steps first!.</span>';
		}

		$monthname = kbdate("F", strtotime("2000-".$home->getMonth()."-2"));
		$smarty->assignByRef( 'awardboxes', $awardboxes );
		$smarty->assign( 'month', $monthname );
		$smarty->assign( 'year', $home->getYear() );
		$smarty->assign( 'boxcount', count( $awardboxes ) );

		return $smarty->fetch( get_tpl( dirname( __FILE__ ) . '/' . 'awards' ) );
	}
	
	public static function getTopKiller( $home, $monthly = true )
	{
		$tklist = new TopKillsList();
		if ($monthly) {
			$tklist->setMonth( $home->getMonth() );
		} else {
			$tklist->setWeek( $home->getWeek() );
		}
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );
		$tklist->setNoStructures();
		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopScorer( $home , $monthly = true)
	{
		$tklist = new TopScoreList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopSoloKiller( $home , $monthly = true)
	{
		$tklist = new TopSoloKillerList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopISKKiller( $home , $monthly = true)
	{
		$tklist = new RankModTopISKKillsList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopDamagedealer( $home , $monthly = true)
	{
		$tklist = new TopDamageDealerList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopFinalBlow( $home , $monthly = true)
	{
		$tklist = new TopFinalBlowList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopPodKiller( $home , $monthly = true)
	{
		$tklist = new TopKillsList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->addVictimShipClass(2); // pod

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopGriefer( $home , $monthly = true)
	{
		$tklist = new TopKillsList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->addVictimShipClass(20); // freighter
		$tklist->addVictimShipClass(22); // exhumer
		$tklist->addVictimShipClass(7);  // industrial
		$tklist->addVictimShipClass(12); // barge
		$tklist->addVictimShipClass(14); // transport
		$tklist->addVictimShipClass(39); // industrial command
		$tklist->addVictimShipClass(43); // exploration ship
		$tklist->addVictimShipClass(29); // capital industrial

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopCapitalKiller( $home , $monthly = true)
	{
		$tklist = new TopKillsList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->addVictimShipClass(20); // freighter
		$tklist->addVictimShipClass(19); // dread
		$tklist->addVictimShipClass(27); // carrier
		$tklist->addVictimShipClass(28); // mothership
		$tklist->addVictimShipClass(26); // titan
		$tklist->addVictimShipClass(29); // cap. industrial

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopStructureKiller( $home , $monthly = true)
	{
		$tklist = new TopKillsList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		involved::load( $tklist,'kill' );

		$tklist->addVictimShipClass( 35 ); // pos small
		$tklist->addVictimShipClass( 36 ); // pos medium
		$tklist->addVictimShipClass( 37 ); // pos large
		$tklist->addVictimShipClass( 38 ); // pos modules
		$tklist->addVictimShipClass( 41 ); // ihub
		$tklist->addVictimShipClass( 42 ); // sov structures

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopPirate( $home , $monthly = true)
	{
		$tklist = new RankModTopSecRelatedKillsList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		$tklist->addSecurityStatus( 0, 0.5 );
		involved::load( $tklist,'kill' );

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopHighsec( $home , $monthly = true)
	{
		$tklist = new RankModTopSecRelatedKillsList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		$tklist->addSecurityStatus( 0.5, 1 );
		involved::load( $tklist,'kill' );

		$tklist->generate();
		
		return $tklist;
	}
	
	public static function getTopLoser( $home , $monthly = true)
	{
		$tklist = new TopLossesList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		$tklist->setNoStructures();
		involved::load( $tklist,'loss' );

		$tklist->generate();
		
		return $tklist;
	}	
	
	public static function getTopHighsecLoser( $home , $monthly = true)
	{
		$tklist = new RankModTopSecRelatedLossesList();
		$tklist->setMonth( $home->getMonth() );
		$tklist->setYear( $home->getYear() );
		$tklist->setNoStructures();
		$tklist->addSecurityStatus( 0.5, 1 );
		involved::load( $tklist,'loss' );

		$tklist->generate();
		
		return $tklist;
	}
}


class RankModAllianceDetails extends RankModCorpDetails
{
	public static function addViews( $home )
	{
		$home->addView( 'rankmod_ranks', "RankModAllianceDetails::viewPilotRanks" );
		$home->addView( 'rankmod_medals', "RankModAllianceDetails::viewPilotMedals" );
		$home->addView( 'rankmod_evolution', "RankModAllianceDetails::viewEvolutionTable" );
		$home->addView( 'rankmod_ribbons', "RankModAllianceDetails::viewRibbons" );
	}
	
	public static function buildMenu( $home )
	{
		$home->addMenuItem( "caption","Awards &amp; Medals" );
		$home->addMenuItem( "link","Pilot awards history", "?a=self_detail&amp;all_id=" . $home->alliance->getID() . "&amp;view=rankmod_medals" );
		$home->addMenuItem( "link","Ribbons", "?a=self_detail&amp;all_id=" . $home->alliance->getID() . "&amp;view=rankmod_ribbons" );
	}
}


class RankModCorpDetails
{
	public static function addViews( $home )
	{
		$home->addView( 'rankmod_ranks', "RankModCorpDetails::viewPilotRanks" );
		$home->addView( 'rankmod_medals', "RankModCorpDetails::viewPilotMedals" );
		$home->addView( 'rankmod_evolution', "RankModCorpDetails::viewEvolutionTable" );
		$home->addView( 'rankmod_ribbons', "RankModCorpDetails::viewRibbons" );
	}
	
	public static function buildMenu( $home )
	{
		$home->addMenuItem( "caption","Awards &amp; Medals" );
		$home->addMenuItem( "link","Pilot awards history", "?a=corp_detail&amp;crp_id=" . $home->corp->getID() . "&amp;view=rankmod_medals" );
		$home->addMenuItem( "link","Ribbons", "?a=corp_detail&amp;crp_id=" . $home->corp->getID() . "&amp;view=rankmod_ribbons" );
		
		$home->addMenuItem( "caption","Corporation ranks" );
		$home->addMenuItem( "link","Pilot ranks", "?a=corp_detail&amp;crp_id=" . $home->corp->getID() . "&amp;view=rankmod_ranks" );
		$home->addMenuItem( "link","Evolution table", "?a=corp_detail&amp;crp_id=" . $home->corp->getID() . "&amp;view=rankmod_evolution" );
	}
	
	public static function viewPilotRanks( $home )
	{
		global $smarty;
		
		#$rank_known = config::get('rankmod_known');
				
		// haxed this a bit, so Moons and Planets do not appear, attention pilots named Moon 1 etc will not apepar
		$query = "SELECT * FROM `kb3_pilots`
			WHERE plt_crp_id = ".$home->corp->getID()."
			AND `plt_name` NOT LIKE '%Warp Disruptor%'
			AND `plt_name` NOT LIKE '%Control Tower%'
			AND `plt_name` NOT LIKE '%Sentry Gun%'
			AND `plt_name` NOT LIKE '%Battery%' 
			AND `plt_name` NOT LIKE '%-%' 
			AND `plt_name` NOT LIKE 'Moon %'
			ORDER BY `plt_name` ASC";
		$qry = new DBQuery();
		$qry->execute($query);
		$temp1=array();
		$temp2=array();
		$temp3=array();
		$pilots=array();
		while ($row = $qry->getRow()) {
		$rank=getPilotRank($row['plt_id'],$kps,$temp1,$temp2,$temp3,$baserps,$bonusrps,$rps, $malusrps);
		$pilots[]=array('plt_id' => $row['plt_id'], 'rank' => $rank, 'rps' => $rps);
		}
		
		if( count( $pilots ) > 0) 
		{
			foreach ($pilots as $i => $data) 
			{
				$ranks[$i]  = $data['rank'];
				$rankpoints[$i] = $data['rps'];
			}
			array_multisort($ranks, SORT_DESC, $rankpoints, SORT_DESC, $pilots);
			$titles = config::get('rankmod_titles');
			
			foreach( $pilots as $key => $plt ) 
			{
				$pilot = new Pilot( $plt['plt_id'] );
				
				$pilot_ranks[$key]['id'] = $pilot->getId();
				$pilot_ranks[$key]['name'] = $pilot->getName();
				$pilot_ranks[$key]['portrait'] = $pilot->getPortraitURL( 32 );
				$pilot_ranks[$key]['rps'] = $plt['rps'];
				$pilot_ranks[$key]['rank_img'] = $titles[$plt['rank']]['img'];
				$pilot_ranks[$key]['title'] = $titles[$plt['rank']]['title'];
				
				$kill_list = new KillList();
				$kill_list->addInvolvedPilot($pilot);
				$kill_list->getAllKills();
				
				$pilot_ranks[$key]['k_score'] = $kill_list->getPoints();					
				if (!$pilot_ranks[$key]['k_score']) { $pilot_ranks[$key]['k_score'] = 0; }
				
				$pilot_ranks[$key]['k_count'] = $kill_list->getCount();
				$pilot_ranks[$key]['k_cost'] = $kill_list->getISK();
				
				$loss_list = new KillList();
				$loss_list->addVictimPilot($pilot);
				$loss_list->getAllKills();
				
				$pilot_ranks[$key]['l_count'] = $loss_list->getCount();
				$pilot_ranks[$key]['l_cost'] = $loss_list->getISK();
				
				if( ( $pilot_ranks[$key]['k_cost'] == 0 ) && ( $pilot_ranks[$key]['l_cost'] == 0 ) ) 
				{
					$pilot_ranks[$key]['efficiency'] = 'N/A';
				} 
				elseif( $pilot_ranks[$key]['k_cost'] == 0 ) 
				{
					$pilot_ranks[$key]['efficiency'] = '0%';
				} 
				elseif( $pilot_ranks[$key]['l_cost'] == 0 ) 
				{
					$pilot_ranks[$key]['efficiency'] = '100%';
				} 
				else 
				{
					$pilot_ranks[$key]['efficiency'] = round( $pilot_ranks[$key]['k_cost'] / ( $pilot_ranks[$key]['k_cost'] + $pilot_ranks[$key]['l_cost'] ) * 100, 2 ).'%';
				}
				
				if( $pilot_ranks[$key]['k_cost'] >= 1000000000 ) 
				{
					$pilot_ranks[$key]['k_cost'] = round($pilot_ranks[$key]['k_cost'] / 1000000000, 2).'B';
				} 
				else 
				{
					$pilot_ranks[$key]['k_cost'] = round($pilot_ranks[$key]['k_cost'] / 1000000, 2).'M';
				}
				
				if( $pilot_ranks[$key]['l_cost'] >= 1000000000 ) 
				{
					$pilot_ranks[$key]['l_cost'] = round($pilot_ranks[$key]['l_cost'] / 1000000000, 2).'B';
				} 
				else 
				{
					$pilot_ranks[$key]['l_cost'] = round($pilot_ranks[$key]['l_cost'] / 1000000, 2).'M';
				}
				
				if( $pilot_ranks[$key]['k_count'] == 0 ) 
				{
					$pilot_ranks[$key]['k_ratio'] = 'N/A';
				} 
				elseif( $pilot_ranks[$key]['l_count'] == 0 ) 
				{
					$pilot_ranks[$key]['k_ratio'] = $pilot_ranks[$key]['k_count'].' : 0';
				} 
				else 
				{
					$pilot_ranks[$key]['k_ratio'] = round($pilot_ranks[$key]['k_count'] / $pilot_ranks[$key]['l_count'], 2).' : 1';
				}
			}
		}
		
		
		if( Session::isAdmin() )
		{
			$smarty->assign( 'admin', 1 );
		}
						
		$smarty->assign( 'pilot_ranks', $pilot_ranks );
		
		return $smarty->fetch( get_tpl( dirname(__FILE__) . '/' . 'corp_detail_ranks' ) );
	}
	
	public static function viewPilotMedals( $home )
	{
		global $smarty;
		
		// fetch medal types
		$medals = RankModMedalTypes::getEnabledMedals();
		
		$smarty->assign( 'medals', $medals );
		
		$RankModMedalsAssigned = new RankModMedalsAssigned();
		$medal_periods = $RankModMedalsAssigned->getAwardPeriods( KB_SITE );
		unset( $RankModMedalsAssigned );
		
		if( count( $medal_periods ) > 0 )
		{
			foreach( $medal_periods as $key => $period )
			{
				list( $time_y, $temp ,$time_m ) = explode( ' ', $period['time_id'] );
				
				$medals_assigned[$key]['time_id'] = $period['time_id'];
				$medals_assigned[$key]['year'] = $time_y;
				$medals_assigned[$key]['month'] = $time_m;
				
				if( count( config::get( 'rankmod_activeawards' ) ) > 0 )
				{
					foreach( config::get( 'rankmod_activeawards' ) as $key2 => $medal_type ) 
					{
						$RankModMedalsAssigned = new RankModMedalsAssigned();
						$assigned = $RankModMedalsAssigned->getAssignedMedalsByTimeAndMedalType( $period['time_id'], $medal_type, KB_SITE );
						unset( $RankModMedalsAssigned );
					
						if( count( $assigned ) > 0 )
						{
							foreach( $assigned as $key3 => $row )
							{
								$RankModMedalsAssigned = new RankModMedalsAssigned( $row['id'] );
								
								
									$Pilot = new Pilot( $RankModMedalsAssigned->getPilotId() );
									
									$medals_assigned[$key]['medals'][$key2]['plt_id'] = $Pilot->getId();
									$medals_assigned[$key]['medals'][$key2]['plt_portrait'] = $Pilot->getPortraitURL();
								
								unset( $RankModMedalsAssigned );
							}
						}
						else
						{
							$medals_assigned[$key]['medals'][$key2]['plt_id'] = "";
							$medals_assigned[$key]['medals'][$key2]['plt_portrait'] = "";
						}
					}
				}
			}
		}
		
		$smarty->assign( 'medals_assigned', $medals_assigned );
		
		return $smarty->fetch( get_tpl( dirname(__FILE__) . '/' . 'corp_detail_medals' ) );
	}
	
	public static function viewEvolutionTable( $home )
	{
		global $smarty;
		
		$smarty->assign( 'rank_imageset', config::get('rankmod_imageset') );
		$rank_titleset = config::get('rankmod_titleset');
		$keep_title = config::get('rankmod_keep');
		$smarty->assign( 'rank_type', config::get('rankmod_rtype') );
		$rank_ttl = config::get('rankmod_titles');
		if ($keep_title) { $words = 'Custom Rank Set'; } else { $words = $rank_titleset." Rank Set"; }
		$smarty->assign( 'words', $words );
		$smarty->assign( 'rank_ttl', $rank_ttl );
		
		return $smarty->fetch( get_tpl( dirname(__FILE__) . '/' . 'corp_detail_evolution' ) );
	}
	
	public static function viewRibbons( $home )
	{
		global $smarty;
		
		$rank_badges = config::get( 'rankmod_badreqs' );
		$rank_sub_badges = config::get( 'rankmod_sub_badreqs' );
		getShipRibbons( $shipbadges );
		
		foreach( $shipbadges as $i => $ship )
		{
			$classes = array( 0 => array( 'tag' => 'elite', 'desc' => 'Combat 1st Class' ), 1 => array( 'tag' => 'veteran', 'desc' => 'Combat 2nd Class' ), 2 => array( 'tag' => 'expert', 'desc' => 'Combat 3rd Class' )  );
			
			foreach( $classes as $j => $class )
			{
				$ships[$i]['type'] = $ship['type'];
				$ships[$i]['name'] = $ship['name'];
				
				if( $ship['type'] == 'kamikaze' ) { $ships[$i]['conj'] = 'like a'; } else { $ships[$i]['conj'] = 'in a'; }
				
				if( isset($ship['parent'] ) ) 
				{
					$ships[$i]['class'][$j]['requirement'] = $rank_sub_badges[$ship['cnt']][$j];
				}
				else 
				{
					$ships[$i]['class'][$j]['requirement'] = $rank_badges[$ship['cnt']][$j];
				}
				
				$ships[$i]['class'][$j]['desc'] = $class['desc'];
				$ships[$i]['class'][$j]['tag'] = $class['tag'];
				$ships[$i]['class'][$j]['tag2'] = ucfirst( $class['tag'] );
			}
		}
		
		$smarty->assign( 'ships', $ships );
		
		getWeaponRibbons( $weaponbadges );
		
		foreach ($weaponbadges as $i => $weap)
		{
			$classes = array( 0 => array( 'tag' => 'elite', 'desc' => 'Master 1st Class' ), 1 => array( 'tag' => 'veteran', 'desc' => 'Master 2nd Class' ), 2 => array( 'tag' => 'expert', 'desc' => 'Master 3rd Class' )  );
			
			foreach( $classes as $j => $class )
			{
				switch ($weap['type']) 
				{
					case 'ew':
						$conj = 'with an';
						$bottom = 'Operator';
						$bottom2 = ' device';
					break;
					case 'missile':
						$conj = 'with a';
						$bottom = 'Operator';
						$bottom2 = ' launcher';
					break;
					case 'drone':
						$conj = 'using';
						$bottom = 'Operator';
						$bottom2 = 's';
					break;
					default:
						$conj = 'with a';
						$bottom = 'Gunner';
						$bottom2 = ' turret';
					break;
				}
				
				$weapons[$i]['type'] = $weap['type'];
				$weapons[$i]['name'] = $weap['name'];
				
				$weapons[$i]['conj'] = $conj;
				$weapons[$i]['bottom'] = $bottom;
				$weapons[$i]['bottom2'] = $bottom2;
				
				$weapons[$i]['class'][$j]['desc'] = $class['desc'];
				$weapons[$i]['class'][$j]['tag'] = $class['tag'];
				$weapons[$i]['class'][$j]['tag2'] = ucfirst( $class['tag'] );
			}
			
		}
		
		$smarty->assign( 'weapons', $weapons );
		
		// fetch medal types
		$medals = RankModMedalTypes::getEnabledMedals();
		
		$smarty->assign( 'medals', $medals );
		
		return $smarty->fetch( get_tpl( dirname(__FILE__) . '/' . 'corp_detail_ribbons' ) );
	}
}


class RankModPilotDetailsPROTOTYPE
{
	public static function addViews( $home )
	{
		/* no extra views yet */
	}
	
	public static function buildMenu( $home )
	{
		/*if( strstr( config::get( "mods_active" ), 'rank_mod' ) )
		{
			$home->addMenuItem( "caption", "Rank" );
			$home->addMenuItem( "link", "Rank & Decorations", "?a=pilot_detail&plt_id=".$home->pilot->getID()."&view=rank_details" );
		}*/
	}
	
	public static function addNewStuff( $home )
	{
		$home->replace( 'stats', "RankModPilotDetails::calculateStats" );
		$home->addBehind( 'start', "RankModPilotDetails::initializeVars" );
	}
	
	public static function initializeVars( $home )
	{
		// initialize medal box vars
		$home->rank = array();
		$home->show_options = array();
		$home->titles = array();
		$home->medals = array();
		$home->shipbadges = array();
		$home->weaponbadges = array();
		$home->rps = 0;
		$home->bonus_rps = 0;
		$home->base_rps = 0;
		$home->malus_rps = 0;
		$home->rank_limit = 0;
		
		// check options for what should be displayed
		$home->show_options = config::get( 'rankmod_show' );
		// load custom rank titles
		$home->titles = config::get( 'rankmod_titles' );
		
		// load rank data
		$home->rank = getPilotRank( $home->plt_id, $points, $home->medals, $home->shipbadges, $home->weaponbadges, $home->base_rps, $home->bonus_rps, $home->rps, $home->malus_rps );
		
		// set maximum rank level
		switch( config::get( 'rankmod_rtype' ) ) 
		{
			case "Enlisted": $home->rank_limit = 9; break;
			case "Officer": $home->rank_limit = 10; break;
			case "Enlisted + Officer": $home->rank_limit = 19; break;
		}
		
		// show current rank in page title
		$home->page->setTitle( $home->titles[$home->rank]['abbr'].' '.$home->pilot->getName() );
	}
	
	public static function calculateStats( &$home )
	{
		global $smarty;
		
		$smarty->assign( 'portrait_URL',$home->pilot->getPortraitURL(128));
		$smarty->assign( 'corp_id',$home->corp->getID());
		$smarty->assign( 'corp_name',$home->corp->getName());
		$smarty->assign( 'all_name',$home->alliance->getName());
		$smarty->assign( 'all_id',$home->alliance->getID());
		$smarty->assign( 'klist_count',$home->klist->getCount());
		$smarty->assign( 'klist_real_count',$home->klist->getRealCount());
		$smarty->assign( 'llist_count',$home->llist->getCount());
		$smarty->assign( 'klist_isk_B',round($home->klist->getISK()/1000000000,2));
		$smarty->assign( 'llist_isk_B',round($home->llist->getISK()/1000000000,2));

		//Pilot Efficiency Mod Begin (K Austin)

		if ($home->klist->getRealCount() == 0)
		{
			$pilot_survival = 100;
			$pilot_efficiency = 0;
		}
		else
		{
			if($home->klist->getRealCount() + $home->llist->getCount()) $pilot_survival = round($home->llist->getCount() / ($home->klist->getRealCount() + $home->llist->getCount()) * 100,2);
			else $pilot_survival = 0;
			if($home->klist->getISK() + $home->llist->getISK()) $pilot_efficiency = round(($home->klist->getISK() / ($home->klist->getISK() + $home->llist->getISK())) * 100,2);
			else $pilot_efficiency = 0;
		}

		$smarty->assign( 'pilot_survival', getPilotSurvivalComparison( $pilot_survival ) );
		$smarty->assign( 'pilot_efficiency', getPilotEfficiencyComparison( $pilot_efficiency ) );
		$smarty->assign( 'pilot_rank', $home->rank );
		$smarty->assign( 'pilot_titles', $home->titles );

		return $smarty->fetch( get_tpl( dirname( __FILE__ ) . '/' . 'pilot_detail_stats' ) );
	}
	
	public static function medalBox( $home )
	{
		global $smarty;
		
		//assign display vars
		if( strpos( config::get('rankmod_show'), 'medal' ) ) { $smarty->assign( 'medalcase_show_medals', 1 ); }
		if( strpos( config::get('rankmod_show'), 'rank' ) ) { $smarty->assign( 'medalcase_show_rank', 1 ); }
		if( strpos( config::get('rankmod_show'), 'badge' ) ) { $smarty->assign( 'medalcase_show_ribbons', 1 ); }
		if( strpos( config::get('rankmod_show'), 'points' ) ) { $smarty->assign( 'medalcase_show_rankpoints', 1 ); }
		if( strpos( config::get('rankmod_show'), 'progression' ) ) { $smarty->assign( 'medalcase_show_progression', 1 ); }
		if( strpos( config::get('rankmod_show'), 'nomeds' ) ) { $smarty->assign( 'medalcase_show_medalribbons', 1 ); }
		// assign values
		$smarty->assign( 'pilot_rank', $home->rank );
		$smarty->assign( 'pilot_ranklimit', $home->rank_limit );
		$smarty->assign( 'pilot_medals', $home->medals );
		$smarty->assign( 'pilot_shipbadges', $home->shipbadges );
		$smarty->assign( 'pilot_weaponbadges', $home->weaponbadges );
		// awardbadges are not calculated seperately in the ranks function, they are identical to the medals
		$smarty->assign( 'pilot_awardbadges', $home->medals );
		$smarty->assign( 'pilot_titles', $home->titles );
		$smarty->assign( 'pilot_rps', $home->rps );
		$smarty->assign( 'pilot_base_rps', $home->base_rps );
		$smarty->assign( 'pilot_bonus_rps', $home->bonus_rps );
		$smarty->assign( 'pilot_malus_rps', $home->malus_rps );echo $home->malus_rps;

		return $smarty->fetch( get_tpl( dirname( __FILE__ ) . '/' . 'pilot_detail_medalbox' ) );
	}
}


class RankModMedalsAssigned extends RankModStandardClass 
{
	public function setId( $value )
	{
		$this->setProperty( "id", $value );
		return $value;
	}
		
	public function getId()
	{
		return $this->getProperty( "id" );
	}
		
	public function setMedalSite( $value )
	{
		$this->setProperty( "med_site", $value );
		return $value;
	}
		
	public function getMedalSite()
	{
		return $this->getProperty( "med_site" );
	}
		
	public function setPilotId( $value )
	{
		$this->setProperty( "plt_id", $value );
		return $value;
	}
		
	public function getPilotId()
	{
		return $this->getProperty( "plt_id" );
	}
		
	public function setMedalId( $value )
	{
		$this->setProperty( "med_id", $value );
		return $value;
	}
		
	public function getMedalId()
	{
		return $this->getProperty( "med_id" );
	}
		
	public function setTimeId( $value )
	{
		$this->setProperty( "time_id", $value );
		return $value;
	}
		
	public function getTimeId()
	{
		return $this->getProperty( "time_id" );
	}
		
	public function getAllAssignedMedals( $med_site )
	{
		$RankModMedalsAssigned = new RankModMedalsAssigned();
		
		$query = sprintf( 
				"SELECT id "
				."FROM kb3_rank_medals_assigned "
				."WHERE med_site = '%s'",
				$med_site );
		
		$this->db->execute( $query );
		
		if( $this->db->recordCount() )
		{
			while( $row = $this->db->getRow() )
			{
				$result[] = $row;
			}
			
			unset( $RankModMedalsAssigned );
			
			return $result;
		}
	}
		
	public function getAssignedMedalTypesByPilot( $pilot_id, $med_id, $med_site )
	{
		$query = sprintf( 
				"SELECT id "
				."FROM kb3_rank_medals_assigned "
				."WHERE plt_id = %d "
				."AND med_id = %d "
				."AND med_site = '%s'",
				$pilot_id,
				$med_id,
				$med_site );
		
		$this->db->execute( $query );
		
		if( $this->db->recordCount() )
		{
			while( $row = $this->db->getRow() )
			{
				$result[] = $row;
			}
			
			return $result;
		}
	}
		
	public function getAssignedMedalsByTimeAndMedalType( $time_id, $med_id, $med_site )
	{
		$query = sprintf( 
				"SELECT id "
				."FROM kb3_rank_medals_assigned "
				."WHERE time_id = '%s' "
				."AND med_id = %d "
				."AND med_site = '%s' "
				."ORDER BY med_id ASC",
				$time_id,
				$med_id,
				$med_site );
		
		$this->db->execute( $query );
		
		if( $this->db->recordCount() )
		{
			while( $row = $this->db->getRow() )
			{
				$result[] = $row;
			}
			
			return $result;
		}
	}
			
	public function getAwardPeriods( $med_site )
	{
		$query = sprintf( 
				"SELECT DISTINCT time_id "
				."FROM kb3_rank_medals_assigned "
				."WHERE med_site = '%s'"
				."ORDER BY time_id DESC",
				$med_site );
		
		$this->db->execute( $query );
		
		if( $this->db->recordCount() )
		{
			while( $row = $this->db->getRow() )
			{
				$result[] = $row;
			}
			
			return $result;
		}
	}
	
	public function saveAssignedMedal( $pilot_id, $medal_id, $date, $site )
	{
		$new_medal = new RankModMedalsAssigned();
		$new_medal->setPilotId( $pilot_id );
		$new_medal->setMedalId( $medal_id );
		$new_medal->setMedalSite($site );
		$new_medal->setTimeId( $date );
		$new_medal->saveObject();
		unset( $new_medal );
	}
			
	public function buildPilotMedalData( $pilot_id )
	{
		$pilot_medals = array();
		
		// loop through medal types
		if( count( config::get( 'rankmod_activeawards' ) ) > 0 )
		{
			foreach( config::get( 'rankmod_activeawards' ) as $key => $medal_type ) 
			{
				// fetch medal data
				$RankModMedalTypes = new RankModMedalTypes( $medal_type );
				
				$pilot_medals[$key]['medal_id'] = $RankModMedalTypes->getId();
				$pilot_medals[$key]['medal_name'] = $RankModMedalTypes->getName();
				$pilot_medals[$key]['medal_title'] = $RankModMedalTypes->getTitle();
				$pilot_medals[$key]['medal_desc'] = $RankModMedalTypes->getDescription();
				$pilot_medals[$key]['medal_filename'] = $RankModMedalTypes->getFilename();
				
				$RankModMedalsAssigned = new RankModMedalsAssigned();
				$medals_assigned = $RankModMedalsAssigned->getAssignedMedalTypesByPilot( $pilot_id, $medal_type, KB_SITE );
				unset( $RankModMedalsAssigned );
				
				if( $medals_assigned )
				{
					foreach( $medals_assigned as $key2 => $value )
					{
						$RankModMedalsAssigned = new RankModMedalsAssigned( $value['id'] );
						$pilot_medals[$key]['medal_award_time'][] = $RankModMedalsAssigned->getTimeId();
						unset( $RankModMedalsAssigned );
					}
				}
				
				unset( $RankModMedalTypes );
			}
		}
		
		return $pilot_medals;
	}
		
	public function loadObject()
	{
		$query = "SELECT med_site, plt_id, med_id, time_id FROM kb3_rank_medals_assigned WHERE id = " . $this->getId();
		
		$this->db->execute( $query );
		
		if( $this->db->recordCount() )
		{
			while( $row = $this->db->getRow() )
			{
				foreach( $row as $key => $value )
				{
					// set the data object property for every db field
					$this->setProperty( $key, $value );
				}
			}
		}
	}
		
	public function saveObject( )
	{
		$query = sprintf( 
				"INSERT INTO kb3_rank_medals_assigned ".
				"( med_site, plt_id, med_id, time_id ) ".
				"VALUES ( '%s', %d, %d, '%s' )", 
				$this->getMedalSite(),
				$this->getPilotId(),
				$this->getMedalId(),
				$this->getTimeId() );
		$this->db->execute($query);
		
		return true;
	}
		
	public function updateObject( )
	{
		return true;
	}
}


class RankModMedalTypes extends RankModStandardClass 
{
	public function setId( $value )
	{
		$this->setProperty( "id", $value );
		return $value;
	}
	
	public function getId()
	{
		return $this->getProperty( "id" );
	}
	
	public function setName( $value )
	{
		$this->setProperty( "name", $value );
		return $value;
	}
	
	public function getName()
	{
		return $this->getProperty( "name" );
	}
	
	public function setStatus( $value )
	{
		$this->setProperty( "active", $value );
		return $value;
	}
	
	public function getStatus()
	{
		return $this->getProperty( "active" );
	}
	
	public function setSorting( $value )
	{
		$this->setProperty( "sorting", $value );
		return $value;
	}
	
	public function getSorting()
	{
		return $this->getProperty( "sorting" );
	}
	
	public function setTitle( $value )
	{
		$this->setProperty( "title", $value );
		return $value;
	}
	
	public function getTitle()
	{
		return $this->getProperty( "title" );
	}
	
	public function setDescription( $value )
	{
		$this->setProperty( "description", $value );
		return $value;
	}
	
	public function getDescription()
	{
		return $this->getProperty( "description" );
	}
	
	public function setFilename( $value )
	{
		$this->setProperty( "filename", $value );
		return $value;
	}
	
	public function getFilename()
	{
		return $this->getProperty( "filename" );
	}
	
	public function getAllMedalTypes()
	{
		$RankModMedalTypes = new RankModMedalTypes();
		
		$query = "SELECT id "
				."FROM kb3_rank_medals_types ORDER BY sorting ASC";
		
		$this->db->execute( $query );
		
		if( $this->db->recordCount() )
		{
			while( $row = $this->db->getRow() )
			{
				$result[] = $row;
			}
			
			unset( $RankModMedalTypes );
			
			return $result;
		}
	}
	
	public function sortMedalUp( $id )
	{
		$RankModMedalTypes = new RankModMedalTypes( $id );
		
		$query = "SELECT DISTINCT id "
				."FROM kb3_rank_medals_types WHERE sorting < " . $RankModMedalTypes->getSorting() . " ORDER BY sorting DESC LIMIT 1";
		$RankModMedalTypes->db->execute( $query );
		
		if( $RankModMedalTypes->db->recordCount() )
		{
			while( $row = $RankModMedalTypes->db->getRow() )
			{
				$previousid = $row['id'];
			}
			
			$query = sprintf( 
					"UPDATE kb3_rank_medals_types ".
					"SET sorting = %d WHERE id = %d", 
					$RankModMedalTypes->getSorting(),
					$previousid );
			
			$RankModMedalTypes->db->execute( $query );
			
			$query = sprintf( 
					"UPDATE kb3_rank_medals_types ".
					"SET sorting = %d WHERE id = %d", 
					$RankModMedalTypes->getSorting()-1,
					$RankModMedalTypes->getId() );
			
			$RankModMedalTypes->db->execute( $query );
		}
		
		unset( $RankModMedalTypes );
	}
	
	public function sortMedalDown( $id )
	{
		$RankModMedalTypes = new RankModMedalTypes( $id );
		
		$query = "SELECT DISTINCT id "
				."FROM kb3_rank_medals_types WHERE sorting > " . $RankModMedalTypes->getSorting() . " ORDER BY sorting ASC LIMIT 1";
		$RankModMedalTypes->db->execute( $query );
		
		if( $RankModMedalTypes->db->recordCount() )
		{
			while( $row = $RankModMedalTypes->db->getRow() )
			{
				$previousid = $row['id'];
			}
			
			$query = sprintf( 
					"UPDATE kb3_rank_medals_types ".
					"SET sorting = %d WHERE id = %d", 
					$RankModMedalTypes->getSorting(),
					$previousid );
			
			$RankModMedalTypes->db->execute( $query );
			
			$query = sprintf( 
					"UPDATE kb3_rank_medals_types ".
					"SET sorting = %d WHERE id = %d", 
					$RankModMedalTypes->getSorting()+1,
					$RankModMedalTypes->getId() );
			
			$RankModMedalTypes->db->execute( $query );
		}
		
		unset( $RankModMedalTypes );
	}
	
	public function getEnabledMedals()
	{
		if( count( config::get( 'rankmod_activeawards' ) ) > 0 )
		{
			foreach( config::get( 'rankmod_activeawards' ) as $key => $medal_type ) 
			{
				// fetch medal data
				$RankModMedalTypes = new RankModMedalTypes( $medal_type );
				
				$medals[$key]['medal_id'] = $RankModMedalTypes->getId();
				$medals[$key]['medal_name'] = $RankModMedalTypes->getName();
				$medals[$key]['medal_title'] = $RankModMedalTypes->getTitle();
				$medals[$key]['medal_desc'] = $RankModMedalTypes->getDescription();
				$medals[$key]['medal_filename'] = $RankModMedalTypes->getFilename();
				$medals[$key]['medal_status'] = $RankModMedalTypes->getStatus();
				$medals[$key]['medal_sorting'] = $RankModMedalTypes->getSorting();
				
				unset( $RankModMedalTypes );
			}
			
			return $medals;
		}
	}
	
	public function getMedals()
	{
		$RankModMedalTypes = new RankModMedalTypes;
		$all_meds = $RankModMedalTypes->getAllMedalTypes();
		unset( $RankModMedalTypes );
		
		if( count( $all_meds ) > 0 )
		{
			foreach( $all_meds as $key => $medal_type ) 
			{
				// fetch medal data
				$RankModMedalTypes = new RankModMedalTypes( $medal_type['id'] );
				
				$medals[$key]['medal_id'] = $RankModMedalTypes->getId();
				$medals[$key]['medal_name'] = $RankModMedalTypes->getName();
				$medals[$key]['medal_title'] = $RankModMedalTypes->getTitle();
				$medals[$key]['medal_desc'] = $RankModMedalTypes->getDescription();
				$medals[$key]['medal_filename'] = $RankModMedalTypes->getFilename();
				$medals[$key]['medal_status'] = $RankModMedalTypes->getStatus();
				$medals[$key]['medal_sorting'] = $RankModMedalTypes->getSorting();
				
				unset( $RankModMedalTypes );
			}
			
			return $medals;
		}
	}
	
	public function loadObject()
	{
		$query = "SELECT DISTINCT id, name, title, description, filename, active, sorting FROM kb3_rank_medals_types WHERE id = " . $this->getId();
		
		$this->db->execute( $query );
		
		if( $this->db->recordCount() )
		{
			while( $row = $this->db->getRow() )
			{
				foreach( $row as $key => $value )
				{
					// set the data object property for every db field
					$this->setProperty( $key, $value );
				}
			}
		}
	}
	
	public function saveObject( )
	{
		return true;
	}
	
	public function updateObject( )
	{
		$query = sprintf( 
				"UPDATE kb3_rank_medals_types ".
				"SET name = '%s', title = '%s', description = '%s', filename = '%s', active = %d, sorting = %d WHERE id = %d", 
				$this->getName(),
				$this->getTitle(),
				$this->getDescription(),
				$this->getFilename(),
				$this->getStatus(),
				$this->getSorting(),
				$this->getId() );
				
		$this->db->Execute( $query );
		
		return true;
	}
}


class RankModAwardBox extends AwardBox 
{
	protected $isk_convert_ = false;
	
	public function setISKConvert()
	{
		$this->isk_convert_ = true;
	}
	
	private function getISKConvertedValue( $val )
	{
		if( $val > 1000000000000) { $val = round( ( $val / 1000000000000 ),0 ); $tag = 'Tril.'; }
		if( $val > 500000000000) { $val = round( ( $val / 5000000000000 ),2 ); $tag = 'Tril.'; }
		if( $val > 1000000000)    { $val = round( ( $val / 1000000000 ),2 ); $tag = 'Bil.'; }
		if( $val > 1000000)       { $val = round( ( $val / 1000000 ),0 ); $tag = 'Mil.'; }
		if( $val > 1000)          { $val = round( ( $val / 1000 ),0 ); $tag = 'Thousand'; }
		
		return $val . ' ' . $tag;
	}
		
	function generate()
    {
        global $smarty;

        $rows = array();
        $max = 0;

        for ($i = 1; $i < 11; $i++)
        {
            $row = $this->toplist_->getRow();
            if ($row)
            {
                array_push($rows, $row);
            }
            if ($row['cnt'] > $max)
            {
                $max = $row['cnt'];
            }
        }

        if (!$rows[0]['plt_id'])
        {
            return;
        }

        $pilot = new Pilot($rows[0]['plt_id']);
        $smarty->assign('title', $this->title_);
        $smarty->assign('pilot_portrait', $pilot->getPortraitURL( 128 ));
        $smarty->assign('award_img', KB_HOST."/mods/rank_mod/images/awards/"
								.$this->award_."_3d.png");
        $smarty->assign('url', edkURI::page("pilot_detail", $rows[0]['plt_id'],
								"plt_id"));
        $smarty->assign('name', $pilot->getName() );

        $bar = new BarGraph($rows[0]['cnt'], $max, 60);
        $smarty->assign('bar', $bar->generate());
        
        $cnt = $rows[0]['cnt'];
        
        if( $this->isk_convert_ )
        {
        	$cnt = $this->getISKConvertedValue( $cnt );
        }
        
        $smarty->assign('cnt', $cnt);

        for ($i = 2; $i < 11; $i++)
        {
            if (!$rows[$i - 1]['plt_id'])
            {
                break;
            }
            if(!$rows[$i - 1]['plt_name'])
            {
                $pilot = new Pilot($rows[$i - 1]['plt_id']);
                $pilotname = $pilot->getName();
            }
            else 
            {
            	$pilotname = $rows[$i - 1]['plt_name'];
            }
            
            $cnt = $rows[$i - 1]['cnt'];
            
            if( $this->isk_convert_ )
	        {
	        	$cnt = $this->getISKConvertedValue( $cnt );
	        }
            $bar = new BarGraph( $rows[$i - 1]['cnt'], $max, 60 );
            $top[$i] = array( 'url'=> "?a=pilot_detail&amp;plt_id=".$rows[$i - 1]['plt_id'], 'name'=>$pilotname, 'bar'=>$bar->generate(), 'cnt'=>$cnt );
        }

        $smarty->assign('top', $top);
        $smarty->assign('comment', $this->comment_);
        return $smarty->fetch( get_tpl( dirname( __FILE__ ) . '/' . 'award_box' ) );
    }
}


class RankModTopSecRelatedKillsList extends TopList
{
	protected $secstatus_ = array();
	
	function addSecurityStatus( $min, $max )
	{
		if( is_numeric( $min ) ) array_push( $this->secstatus_, $min );
		if( is_numeric( $max ) ) array_push( $this->secstatus_, $max );
	}

	function generate()
	{
		$sqlT = "SELECT COUNT( ind.ind_kll_id ) AS cnt, ind.ind_plt_id AS plt_id, plt.plt_name 
                FROM kb3_kills kll 
				INNER JOIN kb3_inv_detail ind ON ( ind.ind_kll_id = kll.kll_id ) 
				INNER JOIN kb3_pilots plt ON ( plt.plt_id = ind.ind_plt_id ) 
				INNER JOIN kb3_systems sys ON ( sys.sys_id = kll.kll_system_id ) 
				";
		
		$this->setSQLTop( $sqlT );

		if (count($this->secstatus_))
		{
			$sqlB .= " AND ( sys.sys_sec < " . $this->secstatus_[1] . " && sys.sys_sec > " . $this->secstatus_[0] .") " ;
		}
		$this->setSQLBottom( $sqlB . " GROUP BY ind.ind_plt_id ORDER BY 1 desc LIMIT ".$this->limit );
	}
}


class RankModTopSecRelatedLossesList extends TopList
{
	protected $secstatus_ = array();
	
	function addSecurityStatus( $min, $max )
	{
		if( is_numeric( $min ) ) array_push( $this->secstatus_, $min );
		if( is_numeric( $max ) ) array_push( $this->secstatus_, $max );
	}
	
	function generate()
	{
		$sqlT = "SELECT COUNT( ind.ind_kll_id ) AS cnt, kll.kll_victim_id AS plt_id, plt.plt_name 
                FROM kb3_kills kll 
				INNER JOIN kb3_inv_detail ind ON ( ind.ind_kll_id = kll.kll_id ) 
				INNER JOIN kb3_pilots plt ON ( plt.plt_id = ind.ind_plt_id ) 
				INNER JOIN kb3_systems sys ON ( sys.sys_id = kll.kll_system_id ) 
				";
		
		$this->setSQLTop( $sqlT );

		if (count($this->secstatus_))
		{
			$sqlB .= " AND ( sys.sys_sec < " . $this->secstatus_[1] . " && sys.sys_sec > " . $this->secstatus_[0] .") " ;
		}
		$this->setSQLBottom( $sqlB . " GROUP BY kll.kll_victim_id ORDER BY 1 desc LIMIT ".$this->limit );
	}
}


class RankModTopISKKillsList extends TopList
{
	function generate()
	{
		$sqlT = "SELECT SUM( kll.kll_isk_loss ) AS cnt, ind.ind_plt_id AS plt_id, plt.plt_name 
                FROM kb3_kills kll 
				INNER JOIN kb3_inv_detail ind ON ( ind.ind_kll_id = kll.kll_id ) 
				INNER JOIN kb3_pilots plt ON ( plt.plt_id = ind.ind_plt_id ) 
				";
		
		$this->setSQLTop( $sqlT );

		$this->setSQLBottom( " GROUP BY ind.ind_plt_id ORDER BY 1 desc LIMIT ".$this->limit );
	}
}


class RankModStandardClass
{
	private $data;
	
	private $errors;
	
	public $last_inserted_id;

		
	public function RankModStandardClass( $object_id = null )
	{
		$this->data = array();
		$this->errors = array();
		$this->last_inserted_id = null;
		$this->db = DBFactory::getDBQuery();
		
		if( !is_null( $object_id ) )
		{
			$this->initializeObject( $object_id );
		}
	}
	
	public function initializeObject( $object_id = null )
	{
		if( $object_id )
		{
			$this->setId( $object_id );
			$this->loadObject();
			
			return true;
		}
		else 
		{
			return false;
		}
	}
	
	public function getObjectData()
	{
		return $this->data;
	}

	protected function setProperty( $name, $value )
	{
		$this->data[$name] = $value;
	}
	
	protected function getProperty( $name )
	{
		if( !isset( $this->data[$name] ) )
		{
			return null;
		}
		else 
		{
			return $this->data[$name];
		}
	}
	
	public function addError( $key = "", $description = "" )
	{
		$this->errors[] = array( "key" => $key, "description" => $description );
	}
	
	public function getErrors()
	{
		return $this->errors;
	}
	
	public function getLastInsertedID()
	{
		return $this->last_inserted_id;
	}
	
	protected function loadObject()
	{
		$dbresult = "";
		$this->fillObject( $dbresult );
	}
	
	protected function fillObject( $dbresult )
	{
		if( is_object( $dbresult) && $dbresult->RecordCount() > 0)
		{
			foreach( $dbresult->fields as $key => $value )
			{
				// set thedata object property for every db field
				$this->setProperty( $key, $value );
			}
			
			return true;
		}
		else 
		{
			return false;
		}
	}
	
	public function saveObject( )
	{
		return true;
	}
	
	public function updateObject( )
	{
		return true;
	}
}


class TopShipListNoLimit extends TopList
{
    function addInvolvedPilot($pilot)
    {
        $this->invplt_ = $pilot;
    }

    function addInvolvedCorp($corp)
    {
        $this->invcrp_ = $corp;
    }

    function addInvolvedAlliance($alliance)
    {
        $this->invall_ = $alliance;
    }

    function generate()
    {
    	// hotfix by Chro'Tal, database layout changed, pilot id is included in kb3_inv_detail now
        $sql = "select count(*) as cnt, ind.ind_shp_id as shp_id, shp.shp_class as cls_id
              from kb3_inv_detail ind
	      inner join kb3_ships shp on ( shp_id = ind.ind_shp_id  
	              and ind.ind_plt_id = ".$this->invplt_->getID().")";

        if ($this->invcrp_)
            $sql .= " inner join kb3_inv_crp inc
	                  on ( inc.inc_kll_id = ind.ind_kll_id
			       and inc.inc_crp_id = ind.ind_crp_id
			       and inc.inc_crp_id = ".$this->invcrp_->getID().")";

        if ($this->invall_)
            $sql .= " inner join kb3_inv_all ina
	                  on ( ina.ina_kll_id = ind.ind_kll_id
			       and ina.ina_all_id = ind.ind_all_id
			       and ina.ina_all_id = ".$this->invall_->getID().")";

        $this->setSQLTop($sql);
        $this->setSQLBottom(" and ind.ind_shp_id != 31
                             and shp.shp_class != 17
                             group by ind.ind_shp_id order by 1 desc");
    }
}


class TopWeaponListNoLimit extends TopList
{
    function addInvolvedPilot($pilot)
    {
        $this->invplt_ = $pilot;
    }

    function addInvolvedCorp($corp)
    {
        $this->invcrp_ = $corp;
    }

    function addInvolvedAlliance($alliance)
    {
        $this->invall_ = $alliance;
    }

    function generate()
    {
        // hotfix by Chro'Tal, database layout changed, pilot id is included in kb3_inv_detail now
        $sql = "select count(*) as cnt, ind.ind_wep_id as itm_id, itm.GroupID as itm_grp
                  from kb3_inv_detail ind
	              inner join kb3_invtypes itm on (typeID = ind.ind_wep_id 
	              and ind.ind_plt_id = ".$this->invplt_->getID().")";

        if ($this->invcrp_)
            $sql .= " inner join kb3_inv_crp inc
	                  on ( inc.inc_kll_id = ind.ind_kll_id
			       and inc.inc_crp_id = ind.ind_crp_id
			       and inc.inc_crp_id = ".$this->invcrp_->getID().")";

        if ($this->invall_)
            $sql .= " inner join kb3_inv_all ina
	                  on ( ina.ina_kll_id = ind.ind_kll_id
			       and ina.ina_all_id = ind.ind_all_id
			       and ina.ina_all_id = ".$this->invall_->getID().")";

        $this->setSQLTop($sql);
        if (DB_USE_CCP)
        {
            // since ccps database doesnt have icons for ships this will also fix the ship as weapon bug
            $this->setSQLBottom(" and itm.volume < '12000'
                                  and itm.typeName != 'Unknown'
                                  group by ind.ind_wep_id order by 1 desc");
        }
        else
        $this->setSQLBottom(" //and itm.itm_icon not in ( '1', 'icon_null' )
                             and itm.itm_name != 'Unknown'
                             group by ind.ind_wep_id order by 1 desc");
    }
}


function TimeID2Str($time_id)
{
  $div = strtok($time_id," - ");
  switch ($div[1]) {
    case "01": $strtime = "January"; break;
    case "02": $strtime = "February"; break;
    case "03": $strtime = "March"; break;
    case "04": $strtime = "April"; break;
    case "05": $strtime = "May"; break;
    case "06": $strtime = "June"; break;
    case "07": $strtime = "July"; break;
    case "08": $strtime = "August"; break;
    case "09": $strtime = "September"; break;
    case "10": $strtime = "October"; break;
    case "11": $strtime = "November"; break;
    case "12": $strtime = "December"; break;
  }
  $strtime .= " ".$div[0];
  return $strtime;
}

function getShips()
{
	return array(
		array( 'type' => 'frigate', 'name' => 'Frigate', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 0
		array( 'type' => 'destroyer', 'name' => 'Destroyer', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),		// 1
		array( 'type' => 'cruiser', 'name' => 'Cruiser', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 2
		array( 'type' => 'battlecruiser', 'name' => 'Battlecruiser', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),	// 3	
		array( 'type' => 'battleship', 'name' => 'Battleship', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),		// 4
		array( 'type' => 'capital', 'name' => 'Capital', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 5
		array( 'type' => 'industrial', 'name' => 'Industrial', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),		// 6
		array( 'type' => 'kamikaze', 'name' => 'Shuttle, Pod & Noobship', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 )	// 7
	);	
}

function getShipSubclasses()
{
	return array(
		array( 'parent' => 0, 'type' => 'assault', 'name' => 'Assault Ship', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 0
		array( 'parent' => 0, 'type' => 'interceptor', 'name' => 'Interceptor', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 1
		array( 'parent' => 0, 'type' => 'covert', 'name' => 'Covert Ops', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),				// 2
		array( 'parent' => 0, 'type' => 'electronic', 'name' => 'Electronic Attack Ship', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),	// 3
		array( 'parent' => 1, 'type' => 'interdictor', 'name' => 'Interdictor', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 4
		array( 'parent' => 2, 'type' => 'hac', 'name' => 'Heavy Assault Cruiser', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 5
		array( 'parent' => 2, 'type' => 'hactor', 'name' => 'Heavy Interdictor', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 6
		array( 'parent' => 2, 'type' => 'logistic', 'name' => 'Logistic Cruiser', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 7
		array( 'parent' => 2, 'type' => 'recon', 'name' => 'Recon Ship', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 8			// 9
		array( 'parent' => 2, 'type' => 't3', 'name' => 'Strategic Cruiser', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ), //9
		array( 'parent' => 3, 'type' => 'command', 'name' => 'Command Ship', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 9
		array( 'parent' => 4, 'type' => 'blackops', 'name' => 'Black Ops', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 10
		array( 'parent' => 4, 'type' => 'marauder', 'name' => 'Marauder', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),				// 11
		array( 'parent' => 5, 'type' => 'dread', 'name' => 'Dreadnought', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),				// 12
		array( 'parent' => 5, 'type' => 'carrier', 'name' => 'Carrier', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),				// 13
		array( 'parent' => 5, 'type' => 'mom', 'name' => 'Mothership', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),				// 14
		array( 'parent' => 5, 'type' => 'titan', 'name' => 'Titan', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),				// 15
		array( 'parent' => 6, 'type' => 'barge', 'name' => 'Mining Barge', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 16
		array( 'parent' => 6, 'type' => 'exhumer', 'name' => 'Exhumer', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),				// 17
		array( 'parent' => 6, 'type' => 'transport', 'name' => 'Transport Ship', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),			// 18
		array( 'parent' => 6, 'type' => 'capindy', 'name' => 'Cap. Industrial', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),		// 19
		array( 'parent' => 7, 'type' => 'noob', 'name' => 'N00bship', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ) // 20
	);	
}
function getWeapons()
{
	return array(
		array( 'type' => 'hybrid', 'name' => 'Hybrid Turret', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),		    // 0
		array( 'type' => 'laser', 'name' => 'Laser Turret', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),		        // 1
		array( 'type' => 'projectile', 'name' => 'Projectile Turret', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),	// 2
		array( 'type' => 'missile', 'name' => 'Missile Launcher', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),		// 3
		array( 'type' => 'ew', 'name' => 'Electronic Warfare', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 ),		    // 4
		array( 'type' => 'drone', 'name' => 'Drone', 'cnt' => 0, 'icon' => 0, 'ribbon' => 0, 'class' => 0 )		                // 5
	);
}

function getShipRibbons( &$ship_badges, $onlyenabled = false )
{
	//all this should be pulled from the database in the future
	$shipbadges = getShips();
	$ship_sub_badges = getShipSubclasses();
	
	$enabled = config::get('rankmod_sub_enabled' );
	
	$ship_badges = array();
	$cnt = 0;
	$last_parent = -1;
	// build ship tree
	foreach( $ship_sub_badges as $subclass ) 
	{
		if( $subclass['parent'] > $last_parent ) 
		{
			$shipbadges[$subclass['parent']]['cnt']=$subclass['parent'];	
			$ship_badges[] = $shipbadges[$subclass['parent']];
			$last_parent = $subclass['parent'];
		}
		
		if( $onlyenabled && strpos( $enabled, $subclass['name'] ) ) 
		{
			$subclass['cnt'] = $cnt;
			$ship_badges[] = $subclass;
		}
		elseif( !$onlyenabled ) 
		{
			$subclass['cnt'] = $cnt;
			$ship_badges[] = $subclass;
		}
		$cnt++;
	}
}

function getWeaponRibbons( &$weapon_badges, $onlyenabled = false )
{
	//all this should be pulled from the database in the future
	$weapon_badges = getWeapons();
}

// custom array sort function
function arrayColumnSort( $marray, $column, $sequence = "desc" )
{
	foreach( $marray as $row )
	{
		$sortarr[] = $row[$column];
	}
	if( $sequence == "desc" )
	{
		array_multisort( $sortarr, SORT_DESC, $marray );
	}
	else
	{
		array_multisort( $sortarr, SORT_ASC, $marray );
	}
	return $marray;
}

function getPilotRank( $pilot_id, &$killpoints, &$pilot_medals, &$ship_badges, &$weaponbadges, &$base_rps, &$bonus_rps, &$rps, &$malus_rps )
{
	if( config::get('rankmod_sub_enabled' ) && 
		config::get( 'rankmod_badreqs' ) && 
		config::get( 'rankmod_convfactor' ) && 
		config::get( 'rankmod_medal_bonus' ) )
	{
		$shipbadges = getShips();
		$ship_sub_badges = getShipSubclasses();
		$weaponbadges = getWeapons();
		
		// set pilot
		$pilot = new Pilot( $pilot_id );
		
		// fetch pilot kills
		$klist = new KillList();
		$klist->addInvolvedPilot($pilot);
		$klist->getAllKills();
		
		// fetch killpoint
		$killpoints = $klist->getPoints();
		
		// build up medal data
		$pilot_medals = RankModMedalsAssigned::buildPilotMedalData( $pilot_id );
		
		// BEGIN ship ribbons code
		$shiplist = new TopShipListNoLimit();
		$shiplist->addInvolvedPilot($pilot);
		$shiplist->generate();
		
		// modified the topshiplist to show also the class (1 query = all data) XD
		
		$excludes = config::get('rankmod_sub_enabled' );
		
		while( $row = $shiplist->getRow() )
		{
			switch ($row['cls_id'])
			{
            case 1: $shipbadges[4]['cnt']+=$row['cnt']; break;
            case 2: $shipbadges[7]['cnt']+=$row['cnt']; break;
            case 3: if( strpos( $excludes, 'noob' ) ) { $ship_sub_badges[21]['cnt']+=$row['cnt']; } else { $shipbadges[7]['cnt']+=$row['cnt']; } break;
            case 4: $shipbadges[0]['cnt']+=$row['cnt']; break;
            case 5: if( strpos( $excludes, 'interceptor' ) ) { $ship_sub_badges[1]['cnt']+=$row['cnt']; } else { $shipbadges[0]['cnt']+=$row['cnt']; } break;
            case 6: if( strpos( $excludes, 'assault' ) ) { $ship_sub_badges[0]['cnt']+=$row['cnt']; } else { $shipbadges[0]['cnt']+=$row['cnt']; } break;
            case 7: $shipbadges[6]['cnt']+=$row['cnt']; break;
            case 8: $shipbadges[2]['cnt']+=$row['cnt']; break;
            case 9: if( strpos( $excludes, 'hac' ) ) { $ship_sub_badges[5]['cnt']+=$row['cnt']; } else { $shipbadges[2]['cnt']+=$row['cnt']; } break;
            case 10: $shipbadges[3]['cnt']+=$row['cnt']; break;
            case 11: $shipbadges[7]['cnt']+=$row['cnt']; break;
            case 12: if( strpos( $excludes, 'barge' ) ) { $ship_sub_badges[17]['cnt']+=$row['cnt']; } else { $shipbadges[6]['cnt']+=$row['cnt']; } break;
            case 13: if( strpos( $excludes, 'logistic' ) ) { $ship_sub_badges[7]['cnt']+=$row['cnt']; } else { $shipbadges[2]['cnt']+=$row['cnt']; } break;
            case 14: if( strpos( $excludes, 'transport' ) ) { $ship_sub_badges[19]['cnt']+=$row['cnt']; } else { $shipbadges[6]['cnt']+=$row['cnt']; } break;
            case 15: $shipbadges[1]['cnt']+=$row['cnt']; break;
            case 16: if( strpos( $excludes, 'covert' ) ) { $ship_sub_badges[2]['cnt']+=$row['cnt']; } else { $shipbadges[0]['cnt']+=$row['cnt']; } break;
            case 19: if( strpos( $excludes, 'dread' ) ) { $ship_sub_badges[13]['cnt']+=$row['cnt']; } else { $shipbadges[5]['cnt']+=$row['cnt']; } break;
            case 21: if( strpos( $excludes, 'command' ) ) { $ship_sub_badges[10]['cnt']+=$row['cnt']; } else { $shipbadges[3]['cnt']+=$row['cnt']; } break;
            case 22: if( strpos( $excludes, 'exhumer' ) ) { $ship_sub_badges[18]['cnt']+=$row['cnt']; } else { $shipbadges[6]['cnt']+=$row['cnt']; } break;
            case 23: if( strpos( $excludes, 'interdictor' ) ) { $ship_sub_badges[4]['cnt']+=$row['cnt']; } else { $shipbadges[1]['cnt']+=$row['cnt']; } break;
            case 24: if( strpos( $excludes, 'recon' ) ) { $ship_sub_badges[8]['cnt']+=$row['cnt']; } else { $shipbadges[2]['cnt']+=$row['cnt']; } break;
            case 26: if( strpos( $excludes, 'titan' ) ) { $ship_sub_badges[16]['cnt']+=$row['cnt']; } else { $shipbadges[5]['cnt']+=$row['cnt']; } break;
            case 27: if( strpos( $excludes, 'carrier' ) ) { $ship_sub_badges[14]['cnt']+=$row['cnt']; } else { $shipbadges[5]['cnt']+=$row['cnt']; } break;
            case 28: if( strpos( $excludes, 'mom' ) ) { $ship_sub_badges[15]['cnt']+=$row['cnt']; } else { $shipbadges[5]['cnt']+=$row['cnt']; } break;
            case 29: if( strpos( $excludes, 'capindy' ) ) { $ship_sub_badges[20]['cnt']+=$row['cnt']; } else { $shipbadges[6]['cnt']+=$row['cnt']; } break;
            case 30: if( strpos( $excludes, 'electronic' ) ) { $ship_sub_badges[3]['cnt']+=$row['cnt']; } else { $shipbadges[0]['cnt']+=$row['cnt']; } break;
            case 31: if( strpos( $excludes, 'hactor' ) ) { $ship_sub_badges[6]['cnt']+=$row['cnt']; } else { $shipbadges[2]['cnt']+=$row['cnt']; } break;
            case 32: if( strpos( $excludes, 'blackops' ) ) { $ship_sub_badges[11]['cnt']+=$row['cnt']; } else { $shipbadges[4]['cnt']+=$row['cnt']; } break;
            case 33: if( strpos( $excludes, 'marauder' ) ) { $ship_sub_badges[12]['cnt']+=$row['cnt']; } else { $shipbadges[4]['cnt']+=$row['cnt']; } break;
            // T3 support!
            case 40: if( strpos( $excludes, 't3' ) ) { $ship_sub_badges[9]['cnt']+=$row['cnt']; } else { $shipbadges[2]['cnt']+=$row['cnt']; } break;
         }
		}
		// END ship ribbons code
		
		//
		// BEGIN weapon ribbons code
		//
		$weaponlist = new TopWeaponListNoLimit();
		$weaponlist->addInvolvedPilot( $pilot );
		$weaponlist->generate();
		
		while ($row = $weaponlist->getRow())
		{
		  $group = $row['itm_grp'];
		  if($group == 771
			|| ($group >= 506 && $group <= 511)
			|| $group == 524
			|| ($group >= 384 && $group <= 387)
			|| ($group >= 394 && $group <= 396)
			|| ($group >= 862 && $group <= 864)
			|| $group == 772
			|| $group == 89
			|| $group == 90
			|| $group == 476
		  ) { $group = 506; }
		  if ($group == 544 
			|| $group == 549
			|| $group == 639
			|| $group == 641
		  ) { $group = 100; }
		  switch ($group)
		  {
			case 53: $weaponbadges[1]['cnt']+=$row['cnt']; break;
			case 55: $weaponbadges[2]['cnt']+=$row['cnt']; break;
			case 74: $weaponbadges[0]['cnt']+=$row['cnt']; break;
			case 506: $weaponbadges[3]['cnt']+=$row['cnt']; break;
			case 100: $weaponbadges[5]['cnt']+=$row['cnt']; break;
			default: $weaponbadges[4]['cnt']+=$row['cnt']; break;
		  }
		}
		
		// END weapon ribbons code
		
		// BEGIN rank points stuff
		
		$bonus_rps = 0;
		$malus_rps = 0;
		$base_rps = round( $killpoints / config::get( 'rankmod_convfactor' ) );
		
		// MEDALS RANKPOINT BONUS
		$rank_medbonus = config::get( 'rankmod_medal_bonus' );
		$rank_losermalus = config::get( 'rankmod_medal_losermalus' );
		
		foreach( $pilot_medals as $i => $med )
		{
			if( ( $med['medal_id'] == 9 || $med['medal_id'] == 14 ) && $rank_losermalus == 1 ) 
			{
				$malus_rps += $rank_medbonus[$i] * count( $med['medal_award_time'] );
			}
			else 
			{
				$bonus_rps += $rank_medbonus[$i] * count( $med['medal_award_time'] );
			}
		}
		
		// SHIP RIBBONS
		$rank_badges = config::get( 'rankmod_badreqs' );
		$rank_badge_value = config::get( 'rankmod_badvalues' );
		foreach( $shipbadges as $i => $ship )
		{
			if( $rank_badges[$i][0] && $ship['cnt'] >= $rank_badges[$i][0] )
			{
				$bonus_rps+=$rank_badge_value[$i][0];
				$shipbadges[$i]['icon']=$ship['type'].'_elite';
				$shipbadges[$i]['class']=$ship['name'].' Combat 1st Class';
				$shipbadges[$i]['badge']='Elite '.$ship['name'].' Pilot';
			} 
			elseif( $rank_badges[$i][1] && $ship['cnt'] >= $rank_badges[$i][1] ) 
			{
				$bonus_rps+=$rank_badge_value[$i][1];
				$shipbadges[$i]['icon']=$ship['type'].'_veteran';
				$shipbadges[$i]['class']=$ship['name'].' Combat 2nd Class';
				$shipbadges[$i]['badge']='Veteran '.$ship['name'].' Pilot';
			} 
			elseif( $rank_badges[$i][2] && $ship['cnt'] >= $rank_badges[$i][2]) 
			{
				$bonus_rps+=$rank_badge_value[$i][2];
				$shipbadges[$i]['icon']=$ship['type'].'_expert';
				$shipbadges[$i]['class']=$ship['name'].' Combat 3rd Class';
				$shipbadges[$i]['badge']='Expert '.$ship['name'].' Pilot';
			}
		}
		
		$shipbadges = arrayColumnSort( $shipbadges, 'badge', 'asc' );
		
		// SHIP SUBCLASS RIBBONS
		$rank_badges = config::get('rankmod_sub_badreqs' );
		$rank_badge_value = config::get('rankmod_sub_badvalues' );
		foreach ($ship_sub_badges as $i => $ship)
		{
			if( $rank_badges[$i][0] && $ship['cnt'] >= $rank_badges[$i][0] )
			{
				$bonus_rps+=$rank_badge_value[$i][0];
				$ship_sub_badges[$i]['icon']=$ship['type'].'_elite';
				$ship_sub_badges[$i]['class']=$ship['name'].' Combat 1st Class';
				$ship_sub_badges[$i]['badge']='Elite '.$ship['name'].' Pilot';
			} 
			elseif( $rank_badges[$i][1] && $ship['cnt'] >= $rank_badges[$i][1] ) 
			{
				$bonus_rps+=$rank_badge_value[$i][1];
				$ship_sub_badges[$i]['icon']=$ship['type'].'_veteran';
				$ship_sub_badges[$i]['class']=$ship['name'].' Combat 2nd Class';
				$ship_sub_badges[$i]['badge']='Veteran '.$ship['name'].' Pilot';
			} 
			elseif( $rank_badges[$i][2] && $ship['cnt'] >= $rank_badges[$i][2] ) 
			{
				$bonus_rps+=$rank_badge_value[$i][2];
				$ship_sub_badges[$i]['icon']=$ship['type'].'_expert';
				$ship_sub_badges[$i]['class']=$ship['name'].' Combat 3rd Class';
				$ship_sub_badges[$i]['badge']='Expert '.$ship['name'].' Pilot';
			}
		}
		
		$ship_badges = array();
		$last_parent = -1;
		foreach( $ship_sub_badges as $subclass ) 
		{
			if( $subclass['parent'] > $last_parent ) 
			{
				$ship_badges[] = $shipbadges[$subclass['parent']];
				$last_parent = $subclass['parent'];
			}
			$ship_badges[] = $subclass;
		}
		
		// WEAPON RIBBONS
		$rank_weap_badges = config::get('rankmod_weapreqs' );
		$rank_weap_badge_value = config::get('rankmod_weapvalues' );
		foreach ($weaponbadges as $i => $weap)
		{
			if( $i == 4 || $i == 3 || $i == 5) { $bottom = 'Operator'; } else { $bottom = 'Gunner';}
			
			if( $rank_weap_badges[$i][0] && $weap['cnt']>=$rank_weap_badges[$i][0] ) 
			{
				$bonus_rps+=$rank_weap_badge_value[$i][0];
				$weaponbadges[$i]['icon'] = $weap['type'].'_elite';
				$weaponbadges[$i]['class'] = $weap['name'].' Master 1st Class';
				$weaponbadges[$i]['badge'] ='Elite '.$weap['name'].' '.$bottom;
			} 
			elseif( $rank_weap_badges[$i][1] && $weap['cnt']>=$rank_weap_badges[$i][1] ) 
			{
				$bonus_rps+=$rank_weap_badge_value[$i][1];
				$weaponbadges[$i]['icon'] = $weap['type'].'_veteran';
				$weaponbadges[$i]['class'] = $weap['name'].' Master 2nd Class';
				$weaponbadges[$i]['badge'] = 'Veteran '.$weap['name'].' '.$bottom;
			} 
			elseif( $rank_weap_badges[$i][2] && $weap['cnt']>=$rank_weap_badges[$i][2] ) 
			{
				$bonus_rps+=$rank_weap_badge_value[$i][2];
				$weaponbadges[$i]['icon'] = $weap['type'].'_expert';
				$weaponbadges[$i]['class'] = $weap['name'].' Master 3rd Class';
				$weaponbadges[$i]['badge'] = 'Expert '.$weap['name'].' '.$bottom;
			}
		}
		
		$weaponbadges = arrayColumnSort( $weaponbadges, 'badge', 'asc' );
		
		$rps = $base_rps + $bonus_rps - $malus_rps;
		$titles = config::get( 'rankmod_titles' );
		$r_type = config::get( 'rankmod_rtype' );
		
		$rank = 0;
		
		while( $rps > $titles[$rank]['reqrp'] && $rank < count( $titles ) )
		{
			$rank++;
		}
		
		if( $rank != 0 ) { $rank--; }
		
		return $rank;
	}
	else 
	{
		echo '<span style="color:red; font-weight:bold;">RankMod has not been configured, thus this page will not display properly. <br><br>Check admin settings and SAVE settings on all config steps first!.</span>';
	}
}

function getPilotSurvivalComparison( $opponent_survival )
{
	global $stats_enemy_survival;
	
	foreach( $stats_enemy_survival as $data )
	{
		if( $opponent_survival >= $data['min'] && $opponent_survival < $data['max'] )
		{
			$return = array( 'percentage' => $opponent_survival, 'desc' => $data['desc'], 'color' => $data['color'] );
			
			return $return;
		}
	}
}

function getPilotEfficiencyComparison( $pilot_efficiency )
{
	global $stats_pilot_efficiency;
	
	foreach( $stats_pilot_efficiency as $data )
	{
		if( $pilot_efficiency > $data['min'] && $pilot_efficiency <= $data['max'] )
		{
			$return = array( 'percentage' => $pilot_efficiency, 'desc' => $data['desc'], 'color' => $data['color'] );
			
			return $return;
		}
	}
}
?>