<?php
/* 
 * Chro'Tal custom signature for rank_mod v2.2
 */

define( 'MPATH', dirname(__FILE__)."/" );

// fetch signature background (400x140px)
$im = imagecreatefromjpeg( MPATH . 'incursion.jpg' );

// define fonts and fontsizes
define( 'MFONT', MPATH . 'Vandiana_Platin_Lite.ttf' );
define( 'FSIZEPILOTNAME', 14 );
define( 'FSIZEKILLS', 10 );
define( 'FSIZE', 8 );

$red = imagecolorallocate($im, 255, 10, 10);
$orange = imagecolorallocate($im, 255, 168, 00);
$blue = imagecolorallocate($im, 0, 0, 200);
$white = imagecolorallocate($im, 255, 255, 255);
$black = imagecolorallocate($im, 0, 0, 0);

$grey_trans = imagecolorallocatealpha($im, 50, 50, 50, 50);
$grey_transblue = imagecolorallocatealpha($im, 181, 181, 181, 70);
$grey_transbluel = imagecolorallocatealpha($im, 50, 50, 110, 100);

// fetch pilot rank (rank_mod required!)
require_once( 'common/includes/class.toplist.php' );
require_once( 'mods/rank_mod/init.php' );

$pilot_titles = config::get( 'rankmod_titles' );
$pilot_rank = getPilotRank( $_GET['i'], $points, $medals, $shipbadges, $weaponbadges, $base_rps, $bonus_rps, $rps, $malus_rps );
$pilot_rank_img_link = $pilot_titles[$pilot_rank]['imglink'];
$pilot_rank_title = $pilot_titles[$pilot_rank]['abbr'];

// set pilot name (including custom text/decoration)
$name = $pilot_rank_title . " " . $pilot->getName();

// fetch latest kill data
$list = new KillList();
$list->setOrdered(true);
$list->setLimit(1);
$list->setPodsNoobships(false);
$list->addInvolvedPilot($pilot);
$kill = $list->getKill();

// render pilot name (aligned right)
$box = imagettfbbox( FSIZEPILOTNAME, 0, MFONT, $name );
$width = $box[4];
imagettftext( $im, FSIZEPILOTNAME, 0, 396-$width, 92, $black, MFONT, $name );
imagettftext( $im, FSIZEPILOTNAME, 0, 394-$width, 90, $white, MFONT, $name );

// render player portrait
$img = imagecreatefromjpeg( Pilot::getPortraitPath( 256, $pid ) );
imagecopyresampled( $im, $img, 330, 8, 0, 0, 63, 63, 256, 256 );
imagedestroy($img);
bevel( 330, 8, 63 );

// render rank image
$img = imagecreatefrompng( MPATH . '../../images/' . $pilot_rank_img_link );
imagecopyresampled( $im, $img, 370, 48, 0, 0, 20, 20, 32, 32 );

// render ribbons
foreach( $shipbadges as $badge )
{
	if( $badge['badge'] )
	{
		$images[] = $badge['icon'] . '.gif';
	}
}
foreach( $weaponbadges as $badge )
{
	if( $badge['badge'] )
	{
		$images[] = $badge['icon'] . '.gif';
	}
}
foreach( $medals as $badge )
{
	if( $badge['medal_award_time'] )
	{
		$images[] = $badge['medal_filename'] . '.gif';
	}
}

$badgecount = 0;
$badgelimit = 6;
$badgewidth = 26;
$badgeheight = 8;
$rowcount = 0;

foreach( $images as $img )
{
	if( $img ) 
	{
		if( $badgecount >= $badgelimit )
		{
			$rowcount++;
			$badgecount = 0;
		}
		$ribbon = imagecreatefromgif( MPATH . '../../images/ribbons/' . $img );
		imagecopyresampled( $im, $ribbon, 238 + ( $badgecount * $badgewidth ), 100 + ( $rowcount * $badgeheight ), 0, 0, $badgewidth, $badgeheight, 106, 30 );
		imagedestroy( $ribbon );
		$badgecount++;
	}
}

function bevel( $x, $y, $size )
{
    global $im, $grey_transblue, $grey_transbluel, $red;
    imagefilledrectangle($im, $x+1, $y+$size-3, $x+$size-1, $y+$size, $grey_transbluel);
    imagefilledrectangle($im, $x+$size-3, $y+1, $x+$size, $y+$size-1, $grey_transbluel);
    imageline($im, $x+1, $y-1, $x+$size, $y-1, $grey_transbluel);
    imagerectangle($im, $x, $y, $x+$size, $y+$size, $grey_transblue);
}
?>
