<?php
/* 
 * Chro'Tal custom signature for rank_mod v2.2
 */

define('MPATH', dirname(__FILE__)."/");

// fetch signature background (400x140px)
$im = imagecreatefromjpeg( MPATH . 'raven.jpg' );

// define fonts and fontsizes
define( 'MFONT', MPATH . 'TrajanPro-Regular.otf' );
define( 'FSIZEPILOTNAME', 18 );
define( 'FSIZEKILLS', 10 );
define( 'FSIZE', 8 );

$red = imagecolorallocate($im, 255, 10, 10);
$orange = imagecolorallocate($im, 255, 168, 00);
$blue = imagecolorallocate($im, 0, 0, 200);
$white = imagecolorallocate($im, 255, 255, 255);
$black = imagecolorallocate($im, 0, 0, 0);

$grey_trans = imagecolorallocatealpha($im, 50, 50, 50, 50);
$grey_transblue = imagecolorallocatealpha($im, 50, 50, 110, 10);
$grey_transbluel = imagecolorallocatealpha($im, 50, 50, 110, 100);

// fetch pilot rank (rank_mod required!)
require_once( 'common/includes/class.toplist.php' );
require_once( 'mods/rank_mod/init.php' );

$pilot_titles = config::get( 'rankmod_titles' );
$pilot_rank = getPilotRank( $_GET['i'], $points, $medals, $shipbadges, $weaponbadges, $base_rps, $bonus_rps, $rps, $malus_rps );
$pilot_rank_img_link = $pilot_titles[$pilot_rank]['imglink'];
$pilot_rank_title = $pilot_titles[$pilot_rank]['abbr'];

// set pilot name (including custom text/decoration)
$name = $pilot_rank_title . " " . $pilot->getName();

// fetch latest kill data
$list = new KillList();
$list->setOrdered(true);
$list->setPodsNoobships(false);
$list->addInvolvedPilot($pilot);
$list->getallKills();
$kill = $list->getKill();

// render pilot name
imagettftext( $im, FSIZEPILOTNAME, 0, 92, 27, $grey_trans, MFONT, $name );
imagettftext( $im, FSIZEPILOTNAME, 0, 90, 25, $white, MFONT, $name );

// render kill count with custom caption
$no = $list->getCount();
$string = $no.' kills';
imagettftext( $im, FSIZEKILLS, 0, 102, 46, $grey_trans, MFONT, $string );
imagettftext( $im, FSIZEKILLS, 0, 100, 44, $white, MFONT, $string );

$string = 'for ' . $alliance->getName();
imagettftext( $im, FSIZEKILLS, 0, 92, 66, $grey_trans, MFONT, $string );
imagettftext( $im, FSIZEKILLS, 0, 90, 64, $white, MFONT, $string );

// render last victim name with custom caption
$string = 'latest victim: ';
imagettftext( $im, FSIZE, 0, 10, 102, $grey_trans, MFONT, $string );
imagettftext( $im, FSIZE, 0, 8, 100, $white, MFONT, $string );

// render last victim details
$string = strtoupper($kill->getVictimName().' - '.$kill->getVictimCorpName());
$box = imagettfbbox(FSIZE, 0, MFONT, $string);
$width = $box[4];
imagettftext($im, FSIZE, 0, 10, 120, $grey_trans, MFONT, $string);
imagettftext($im, FSIZE, 0, 8, 118, $white, MFONT, $string);

$string = 'in a ' . strtoupper($kill->getVictimShipName());
$box = imagettfbbox(FSIZE, 0, MFONT, $string);
$width = $box[4];
imagettftext($im, FSIZE, 0, 10, 134, $grey_trans, MFONT, $string);
imagettftext($im, FSIZE, 0, 8, 132, $white, MFONT, $string);

// render player portrait
$img = imagecreatefromjpeg(Pilot::getPortraitPath( 256, $pid ) );
imagecopyresampled( $im, $img, 8, 8, 0, 0, 63, 63, 256, 256 );
imagedestroy($img);
bevel( 8, 8, 63 );

// render rank image
$img = imagecreatefrompng( "mods/rank_mod/images/".$pilot_rank_img_link );
imagecopyresampled( $im, $img, 52, 48, 0, 0, 20, 20, 32, 32 );


function bevel( $x, $y, $size )
{
    global $im, $grey_transblue, $grey_transbluel, $red;
    imagefilledrectangle($im, $x+1, $y+$size-3, $x+$size-1, $y+$size, $grey_transbluel);
    imagefilledrectangle($im, $x+$size-3, $y+1, $x+$size, $y+$size-1, $grey_transbluel);
    imageline($im, $x+1, $y-1, $x+$size, $y-1, $grey_transbluel);
    imagerectangle($im, $x, $y, $x+$size, $y+$size, $grey_transblue);
}
?>
